# BITHockeyAppClient Class Reference

Inherits from | NSObject
Declared in | BITHockeyAppClient.h

## Overview

Generic Hockey API client

## Tasks

- `– initWithBaseURL:`
- `baseURL` property
- `– requestWithMethod:path:parameters:`
- `– operationWithURLRequest:completion:`
- `– getPath:parameters:completion:`
- `– postPath:parameters:completion:`
- `– enqeueHTTPOperation:`
- `– cancelOperationsWithPath:method:`
- `operationQueue` property
- `+ dataWithPostValue:forKey:boundary:`

## Properties

### baseURL

    baseURL to which relative paths are appended

`@property (nonatomic, strong) NSURL *baseURL`

#### Declared In

`BITHockeyAppClient.h`

### operationQueue

    Access to the internal operation queue

`@property (nonatomic, strong) NSOperationQueue *operationQueue`

#### Declared In

`BITHockeyAppClient.h`

## Class Methods

### dataWithPostValue:forKey:boundary:

    create a post body from the given value, key and boundary

c/p from HockeyBaseManager

`+ (NSData *)dataWithPostValue:(NSString *)value forKey:(NSString *)key boundary:(NSString *)boundary`

#### Parameters

value

  -

key

  -

boundary

  -

#### Return Value

NSData instance configured to be attached on a (post) URLRequest

#### Declared In

`BITHockeyAppClient.h`

## Instance Methods

### cancelOperationsWithPath:method:

    cancels the specified operations

`- (NSUInteger)cancelOperationsWithPath:(NSString *)path method:(NSString *)method`

#### Parameters

path

  the path which operation should be cancelled. Can be nil to match all

method

  the method which operations to cancel. Can be nil to match all

#### Return Value

number of operations cancelled

#### Declared In

`BITHockeyAppClient.h`

### enqeueHTTPOperation:

    adds the given operation to the internal queue

`- (void)enqeueHTTPOperation:(BITHTTPOperation *)operation`

#### Parameters

operation

  operation to add

#### Declared In

`BITHockeyAppClient.h`

### getPath:parameters:completion:

    Creates an operation for the given path, and enqueues it

`- (void)getPath:(NSString *)path parameters:(NSDictionary *)params completion:(BITNetworkCompletionBlock)completion`

#### Parameters

path

  the request path to check

params

  parameters for the request

completion

  completionBlock that is called once the operation finished

#### Declared In

`BITHockeyAppClient.h`

### initWithBaseURL:

    designated initializer

`- (instancetype)initWithBaseURL:(NSURL *)baseURL`

#### Parameters

baseURL

  the baseURL of the HockeyApp instance

#### Declared In

`BITHockeyAppClient.h`

### operationWithURLRequest:completion:

    Creates an operation for the given NSURLRequest

`- (BITHTTPOperation *)operationWithURLRequest:(NSURLRequest *)request completion:(BITNetworkCompletionBlock)completion`

#### Parameters

request

  the request that should be handled

completion

  completionBlock that is called once the operation finished

#### Return Value

operation, which can be queued via enqueueHTTPOperation:

#### Declared In

`BITHockeyAppClient.h`

### postPath:parameters:completion:

    Creates an operation for the given path, and enqueues it

`- (void)postPath:(NSString *)path parameters:(NSDictionary *)params completion:(BITNetworkCompletionBlock)completion`

#### Parameters

path

  the request path to check

params

  parameters for the request

completion

  completionBlock that is called once the operation finished

#### Declared In

`BITHockeyAppClient.h`

### requestWithMethod:path:parameters:

    creates an NRURLRequest for the given method and path by using

the internally stored baseURL.

`- (NSMutableURLRequest *)requestWithMethod:(NSString *)method path:(NSString *)path parameters:(NSDictionary *)params`

#### Parameters

method

  the HTTPMethod to check, must not be nil

path

  path to append to baseURL. can be nil in which case “/” is appended

params

  parameters for the request (only supported for GET and POST for now)

#### Return Value

an NSMutableURLRequest for further configuration

#### Declared In

`BITHockeyAppClient.h`